#ifndef _RAIDAPI_H
#define _RAIDAPI_H


/****************************************************************************
 *                                                                          *
 * Copyright (c) 1996-99 Promise Technology, Inc.  All rights reserved.     *
 * No part of this document may be reproduced or transmitted in any form or *
 * by any means, electronic or mechanical, for any purpose, without the     *
 * express written permission of Promise Technology, Inc.                   *
 *                                                                          *
 ****************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/* The following flag must be defined when compiling the API */
/* Users of the API must NOT define this flag                */

#define RAIDAPI
#define VERSION	"v1.30.0.11"//modiy by steven on 12/17
#define VERDATE "(2002.05.10)"

/* CONSTANTS */

//const int RAMAX_DISK = 32;
//const int RAMAX_ARRAY=8;
//const int RAMAX_DISK_PER_ARRAY=8;
//const int RAMAX_CHARS_DISKNAME=(20*sizeof(short));

#define RAMAX_DISK 8
#define RAMAX_CHANNEL 4 //added by reevyn for SX4
#define RAMAX_ARRAY 8
#define RAMAX_DISK_PER_ARRAY 8
#define RAMAX_CHARS_DISKNAME 40
#define RAMAX_EVENTS 20
//add 10.29 for battery
#define GAUGE_BQ2060	0x16
#define BQ_2060_BATTERY_STATUS_OVER_CHARGED_ALARM		0x8000
#define BQ_2060_BATTERY_STATUS_TERMINATE_CHARGE_ALARM   	0x4000
#define BQ_2060_BATTERY_STATUS_OVER_TEMP_ALARM          	0x1000
#define BQ_2060_BATTERY_STATUS_TERMINATE_DISCHARGE_ALARM	0x0800
#define BQ_2060_BATTERY_STATUS_REMAINING_CAPACITY_ALARM 	0x0200
#define BQ_2060_BATTERY_STATUS_REMAINING_TIME_ALARM     	0x0100
#define BQ_2060_BATTERY_STATUS_INITIALIZED			0x0080
#define BQ_2060_BATTERY_STATUS_DISCHARGING 			0x0040
#define BQ_2060_BATTERY_STATUS_FULLY_CHARGED			0x0020
#define BQ_2060_BATTERY_STATUS_FULLY_DISCHARGED			0x0010
#define BQ_2060_BATTERY_STATUS_Unknown_Error     		0x0007
#define BQ_2060_BATTERY_STATUS_BadSize          		0x0006
#define BQ_2060_BATTERY_STATUS_OverflowUnderflow		0x0005
#define BQ_2060_BATTERY_STATUS_AccessDenied      		0x0004
#define BQ_2060_BATTERY_STATUS_UnsupportedCommand		0x0003
#define BQ_2060_BATTERY_STATUS_ReservedCommand   		0x0002
#define BQ_2060_BATTERY_STATUS_Busy              		0x0001
#define BQ_2060_BATTERY_STATUS_OK                		0x0000
#define BQ_2060_COMMAND_TEMPETURE		0x08
#define BQ_2060_COMMAND_VOLTAGE	    		0x09
#define BQ_2060_COMMAND_BATTERY_STATUS		0x16
#define BQ_2060_COMMAND_CYCLE_COUNT		0x17
#define BATTERY_BACKUP_MODULE_EXIST		0x00
//
#define raeNoError(eStatus)  ( eStatus == reSOK )

/* ENUMERATED TYPES */
typedef enum _raeAction
{
	reGET=0,
	reSET
} raeAction;

typedef enum _raeStatus
{
    reSNotImplemented=-1,
    reSOK,
    reSApiNotInitialized,
    reSGenericError,
    reSFunctionNotSupported,
    reSNoAdapter,
    reSDriverNotFound,
    reSVersionMismatch,
    reSNoDiskPresent,
    reSInvalidArrayId,
    reSArrayStatusError,
    reCannotCreateMailslot,
    reSNoSuchArray,
    reSInvalidArrayNumber,
    reSErrorCreatingArray,
    reSInvalidRAIDMode,
    reSInvalidArrayConfiguration,
    //<<reSErrorExpanConvArray //added by reevyn
    //<<add for expan error 12.19
    reSTargetSizeToosmall,
    reSSameArrayError,
    reSInvalidDisk,
    reSArrayBusy   //added by steven for linux
    //<<
} raeStatus;

//added by steven on 01/08/2002
typedef enum _raeHardwareType
{
   reFastTrak=0,//FastTrak100 or FastTrakTX
   reFastTrakSX,//FastTrak4000 or FastTrak8000
   reSuperTrak,//SuperTrak100
   reSuperTrakSX,//SuperTrakSX6000
   reUltraTrakSX//UltraTrakSX8000
}raeHardwareType;
//end of added by steven on 01/08/2002

typedef enum _raeChannelType
{
    reChannelUnknown=-1,
    reChannelInvalid,
    reChannelIde,
    reChannelScsi,
    reChannelEnclosure,
    reChannel1394,
} raeChannelType;

typedef enum _raeDeviceType
{
    reDeviceUnknown=-1,
    reDeviceNone,
    reDeviceIdeDisk,
    reDeviceStorage,  /* other type of storage */
    reDeviceCdrom,
    reDeviceArray,
    reDeviceFan,
    reDevicePower,
    reDeviceTemperature,
    reDeviceVoltage
} raeDeviceType;

typedef enum _raeArrayFunctionalStatus
{
    reArrayFunctionalStatusUnknown=-1,
	reArrayFunctional,
	reArrayCritical,
	reArrayOffline
} raeArrayFunctionalStatus;

typedef enum _raeRaidMode
{
    reRaidModeUnknown=-1,
    reRaidModeStriping,
    reRaidModeMirroring,
    reRaidModeStripeMirroring,
    reRaidModeSpan,
    reRaidModeParity,
    reRaidModeParityDistributed
} raeRaidMode;

typedef enum _raeArrayActivityStatus
{
    reArrayActivityStatusUnknown=-1,
    reArrayIdle,
    reArrayRebuilding,
    reArrayEngineRebuilding,
    reArraySynchronizing,
    reArrayExpanding,
    //<<add 2002.1.11
	reArrayRebuildPause,
	reArrayExpanPause,
	reArraySyncPause
} raeArrayActivityStatus;

typedef enum _raeDiskFunctionalStatus
{
    raeDiskFunctionalStatusUnknown=-1,
    reDiskFunctional,
    reDiskOffline,
    reDiskFunctionalNeedsRebuilding
} raeDiskFunctionalStatus;

typedef enum _raeDiskAssignmentStatus
{
    raeDiskAssignmentStatusUnknown=-1,
    reDiskFree,
	reDiskAssigned,
	reDiskSpare,
	reDiskClaimed
} raeDiskAssignmentStatus;

typedef enum _raeDiskTiming
{
    reDiskTimingUnknown=-1,
    reDiskTimingUDMA4,
    reDiskTimingUDMA3,
    reDiskTimingUDMA2,
    reDiskTimingUDMA1,
    reDiskTimingUDMA0,
    reDiskTimingDMA2,
    reDiskTimingDMA1,
    reDiskTimingDMA0,
    reDiskTimingUDMA5
} raeDiskTiming;

typedef enum _raeEventType
{
    reEventUnknown=-1,
    reEventECCError,
    reEventDiskDown,
    reEventDiskPlugin,
    reEventBadSector,
    reEventRebuildStart,
    reEventSyncStart,
    reEventExpanConvStart, //added by steven on 6/22/2001  6
    reEventDiskRetry,
    reEventArrayCritical,
    reEventArrayOffline,
    reEventRebuildCompleted,
    reEventSyncCompleted,
    reEventExpanConvCompleted,//added by steven on 6/22/2001  12
    reEventDiskMediaError,
    reEventReservedSectorError,
    reEventRebuildAborted,
    reEventSyncAborted,
    reEventExpanConvAborted,//added by steven on 6/22/2001  17
    reEventSyncComparisonError,
	 reEventSMARTError,
	 reEventSwapPowerDown,  /*powerdown swap enclosure*/
	 reEventSwapPowerUp,    /*powerup swap enclosure*/
	 reEventSwapBadSwap,    /*bad disk swap, power down*/  //22
    reEventSwapOverTemp,
    reEventSwapFanStop,
    reEventSwap12VOutOfRange,
    reEventSwap5VOutOfRange,
    //<< add 12.03
    reEventArrayCreate,
    reEventArrayDelete
    //<<

} raeEventType;

typedef enum _raeEventLevel
{
    reInformational,
    reWarning,
    reError
} raeEventLevel;

typedef struct _rasEvent
{
    raeEventType eType;
    raeEventLevel eLevel;
	int aID;  //Array ID of generator(-1 == not used)
	int dID;  //Disk ID of generator (-1 == not used)
    char desc[128];
} rasEvent;

/* continue flag to re-start rebuild/synchronize */
typedef enum _raeIgnoreFix
{
	raeStart,
	raeFix,
	//add by steven on 12/27/2001
	raeIgnore,
	raePause,
	raeStop,
	raeContinue
} raeIgnoreFix;

typedef enum _raeDiskMaintenanceActivity
{
	raeMaintenanceNone,
	raeMaintenanceRebuilding,
	raeMaintenanceSynchronizing,
	raeMaintenanceConverting //added by reevyn
} raeDiskMaintenanceActivity;

typedef enum _raeDiskSMARTStatus
{
	raeSMARTUnknown,
	raeSMARTOK,
	raeSMARTFail,  /* disk F/W predict failure */
	raeSMARTNotSupported,
	raeSMARTNotAvailable /* driver does not check status */
} raeDiskSMARTStatus;

typedef enum _raeEnclosureType
{
    raeNone,
	raeNoDrive,
	raeFastSwap,
	raeSuperSwap,
	raeUniversalSwap,//added by steven on 6/22/2001
	raeUnknown
} raeEnclosureType;

//add 10.24 to support battery manage
typedef enum _raeBatteryStatus
{
	reBatteryStatusUnknown=-1,
	reBatteryOK,
	reBatteryBusy,
	reBatteryReservedCommand,
	reBatteryUnsupportedCommand,
	reBatteryAccessDenied,
	reBatteryOverflowUnderflow,
	reBatteryBadSize,
	reBatteryUnknownError,
	reBatteryFullyDischarged,
	reBatteryFullyCharged,
	reBatteryDischarging,
	reBatteryInitialized,
	reBatteryRemainingTimeAlarm,
	reBatteryRemainingCapacityAlarm,
	reBatteryTerminateDischargeAlarm,
	reBatteryOverTempAlarm,
	reBatteryTerminateChargeAlarm,
	reBatteryOverChargedAlarm
} raeBatteryStatus;

//add 11.01 to support log event error level
typedef enum _raeErrorLevel
{
	reErrorNormal,
	reErrorPlus,
	reErrorPremium,
	reErrorCritical
} raeErrorLevel;
//
//<<11.26
typedef enum _raeWriteMode
{
	reNotSupport=-1,
	reWriteBack,
	reWriteThrough
} raeWriteMode;

typedef struct _rasFastSwap
{
    int wFanSpeed;
} rasFastSwap;

typedef struct _rasSuperSwap
{
    int wFanSpeed;
	int wTemperature;
	int w5VVoltage;
	int w12VVoltage;
} rasSuperSwap;

typedef struct _rasUniversalSwap  //added by steven on 6/22/2001
{
    int wFanSpeed;
	int wTemperature;
	int w5VVoltage;
	int w12VVoltage;
	int wKey;
} rasUniversalSwap;

typedef union _rauEnclosureData
{
	rasFastSwap sFastSwap;
	rasSuperSwap sSuperSwap;
	rasUniversalSwap sUniversalSwap;//added by steven on 6/22/2001
} rauEnclosureData;

typedef struct raidstrm {
  unsigned char blFlag;                                  /* see BLOCK.blFlag */
  unsigned char bIndex;
  unsigned char bDuplicateIndex;
  unsigned char bRedirectIndex;
} RAIDSTRM;

//
// raid type index
//
typedef enum {
	RAID_UNKNOWN_ARRAY=-1,
	RAID_STRIP_ARRAY,					// RAID0 stripe
	RAID_MIRROR_ARRAY,					// RAID1 two disk mirror
	RAID_STRIPMIRROR_ARRAY,				// RAID1 more than one pair of disks mirror
	RAID_SPAN_ARRAY,						// one after the other continuously
	RAID_PARITY_ARRAY,					// future use
	RAID_PARITYDISTRIBUTED_ARRAY			// future use
} RAIDTYPE;

//added by reevyn for sx4
typedef struct _rasArrayInfo
{
	unsigned long	NumberDisks;		// total disks under this array
	char	Name[64];			// array names
	unsigned long	Status;				// array status, (index of array image)
	RAIDSTRM	strm[RAMAX_ARRAY];
								// disks under this array
	RAIDTYPE	RAID;			// RAID type
	unsigned char	blFlag;				// Array status
	unsigned char	bWidth;				// Phisical Disks (?= NumberDisks)
	unsigned char	bLogicalWidth;		// Stripe Width;
	short	hStripeBlockSize;	// Stripe Block Size
	unsigned short	NumberOfCylinders;	// #Cylinder
	unsigned short  NumberOfHeads;		// #Heads
	unsigned short	SectorsPerTrack;	// #Sectors/Track
	long	ulSize;				// CHS size in byte
} rasArrayInfo;

typedef struct _rasControllerInfo
{
	unsigned long	NumberChannels;		// number of channels this controller have.
	//char	Name[32];			// Controller name
	//unsigned long	Status;				// Controller status (image index)

	unsigned long   BusMasterBase;		// Controller base;
	unsigned long	IRQ;				// Interrupt number;
	unsigned long	SlotNumber;			// Slot this controller take place;
	unsigned long	BIOSMemStart;		// BIOS rom start address
	unsigned long   BIOSMemRange;		// size of BIOS rom

	//add for sx4 by reevyn
	unsigned long  BaseAddressATA;       // For ATA
	unsigned long  BaseAddressXOR;       // For XOR, HOST DMA.
	unsigned long  BaseAddressSEQ;       // For SEQ
    unsigned long  BaseAddressMMIO;       // For memory mapped IO
    unsigned long  BaseAddressSDRAM;       // For SDRAM

} rasControllerInfo;


//
// IDE register definition
//

typedef struct RAID_IDE_REGISTERS_1 {
    unsigned short Data;
    unsigned char BlockCount;
    unsigned char BlockNumber;
    unsigned char CylinderLow;
    unsigned char CylinderHigh;
    unsigned char DriveSelect;
    unsigned char Command;
} RAID_IDE_REGISTERS_1;

typedef struct RAID_IDE_REGISTERS_2 {
   unsigned char AlternateStatus;
   unsigned char DriveAddress;
} RAID_IDE_REGISTERS_2;

typedef struct _rasChannelInfo
{
	unsigned long	NumberDisks;		// Number of disks in this Channel
	char	Name[32];			// Channel name
	unsigned long	Status;				// Channel Status; (image index)

	RAID_IDE_REGISTERS_1	*BaseIoAddress1;	// Base io address 1st set;
	RAID_IDE_REGISTERS_2	*BaseIoAddress2; // Base io address 2nd set;

	unsigned long	LogicalChannelNumber;	// Logical channel number in the system

} rasChannelInfo;

typedef struct _rasDiskInfo
{
	unsigned long	Status;				// Disk status (image index)

	unsigned long	NumberOfCylinders;	// #Cylinder
	unsigned short  NumberOfHeads;		// #Heads
	unsigned short	SectorsPerTrack;	// #Sectors/Track

	unsigned char	bBlkFlag;			// DiskBlok usage and running status flag
	unsigned char	bStrmFlag;			// array stream flag

	float	wSize;				// CHS size in byte

	unsigned char	bAdapter;			// Controller #
	unsigned char	bCh;				// Channel # of this disk
	unsigned char	bID;				// Master or slave;
	unsigned char	bArray;				// Array # of this disk

	unsigned char *DmaCycleTimingMode;	// DMA mode;
	unsigned short	UDMAMode;			// UDMA mode;
	unsigned short	Capabilities;		// capability bits
	unsigned short	ValidBit;			// valid of UDMA mode

	char	Name[20*sizeof(short)];
								// Model name of this disk
} rasDiskInfo;


typedef struct _rasLogEvent{
  	unsigned long id;
	unsigned long TimeStamp;
	unsigned long QueueNum;
	unsigned long NumOfParams;
	unsigned long WarningLevel;
	union {
		struct {
			unsigned long wDiskID;                            /* ATA feature Register */
		} disk_offline;
		struct {
			unsigned long wDiskID;                            /* # of sctr to process upto 128 */
		} disk_setdown;
		struct {
			unsigned long wArrayID;                                /* starting sector location */
		} array_setdown;
		struct {
			unsigned long wArrayID;                                /* starting sector location */
		} array_degrade;
		struct {
			unsigned long wDiskID;                                /* starting sector location */
		} plug_in;
		struct {
			unsigned long wLBA;
			unsigned long wDiskID;
		} disk_retry;
		struct {
			unsigned long wLBA;
			unsigned long wDiskID;
		} reserved_sector_error;
		struct {
			unsigned long wLBA;
			unsigned long wDiskID;
			unsigned long wArrayID;
			unsigned long wStatus;
		} ecc_error;
		struct {
		        unsigned long wArrayID;       /* ATA feature Register */
		}array_create;
		struct {
		        unsigned long wArrayID;       /* ATA feature Register */
		}array_delete;
		struct {
			unsigned long wArrayID;                            /* ATA feature Register */
			unsigned long wDiskID;
		} rebuild_start;
		struct {
			unsigned long wArrayID;
		} sync_start;
		struct {
			unsigned long wArrayID;                            /* ATA feature Register */
			unsigned long wDiskID;                              /* # of sctr to process upto 128 */
			unsigned long percent;                                /* ATA Command Register */
		} rebuild_complete;
		struct {
			unsigned long wArrayID;                            /* ATA feature Register */
			unsigned long percent;                                /* ATA Command Register */
		} sync_complete;
		struct {
			unsigned long wArrayID;                            /* ATA feature Register */
			unsigned long wDiskID;                              /* # of sctr to process upto 128 */
			unsigned long percent;                                /* ATA Command Register */
		} rebuild_abort;
		struct {
			unsigned long wArrayID;                            /* ATA feature Register */
			unsigned long percent;                                /* ATA Command Register */
		} sync_abort;
		struct {
			unsigned long wLBA;
			unsigned long wLBAEnd;
			unsigned long wArrayID;
		} sync_comp_error;
		struct {
			unsigned long wArrayID;                            /* ATA feature Register */
			unsigned long wDiskID;                              /* # of sctr to process upto 128 */
			unsigned long wLBA;
			unsigned long wChannel;                                /* ATA Command Register */
			unsigned long wCmd;
			unsigned long wStatus;                             /* ATA Status Register */
		} disk_error;
		struct {
			unsigned long wDiskID;
		} smart_error;
		struct {
			unsigned long wChannel;
			unsigned long wID;
		} swap_box_error;
		struct {
			unsigned long wChannel;
			unsigned long wID;
			unsigned long value;   /* param value fan=rpm, 5v/1v=millivolts, temp=2*degC*/
		}swap_box_monitor_error;
	} ParamList;
}rasLogEvent;




/*  FUNCTION HEADERS */

/*
 * Function:        raInitialize
 *
 * Description:     Initialize the API
 *
 * Input:           none
 *
 * Output:          Handle
 *
 * Errors:          reNoAdapter
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raInitialize(void **pHandle);


/*
 * Function:        raTerminate
 *
 * Description:     Ternimate the API
 *
 * Input:           API Handle
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raTerminate(void *pHandle);

/*
 * Function:        raErrorDescription
 *
 * Description:     Get a description of the error status
 *
 * Input:           error status code
 *
 * Output:          string
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */
RAIDAPI const char *raErrorDescription(raeStatus eStatus);


/*
 * Function:        raGetNumberOfAdapters
 *
 * Description:     Get Number of Adapters
 *
 * Input:           none

 *
 * Output:          number of adapters
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetNumberOfAdapters(int *numAdapters);

/*
 * Function:        raGetMaxChannelsPerAdapter
 *
 * Description:     Get the Maximum number of channels per adapter
 *
 * Input:           none
 *
 * Output:          max channels
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetMaxChannelsPerAdapter(int *maxChannels);

/*
 * Function:        raGetMaxDeviceInChannel
 *
 * Description:     Get the max. number of devices that can exist on a
 *                  particular channel
 *
 * Input:           channel number (0 based)
 *
 * Output:          Max devices
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetMaxDeviceInChannel(int iChannel, int *numMaxDevice);

/*
 * Function:        raScanChannel
 *
 * Description:     Scan the type of channel
 *
 * Input:           Adapter ID, Channel ID
 *
 * Output:          Channel Type, Channel ID
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raScanChannel(int iAdapter, int iChannel,
                                raeChannelType *eChType, int *nChannelId);
/*
 * Function:        raScanDevice
 *
 * Description:     Scan whether a device is present on a particualar channel
 *                  and ID, and what is the type of device present
 *
 * Input:           Channel, ID
 *
 * Output:          Device Type
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raScanDevice(int iChannel, int iID, raeDeviceType *eDevType,
                               int *nDeviceId);

/*
 * Function:        raGetDeviceName
 *
 * Description:     Get the name of the device (array or disk)
 *
 * Input:           DeviceId
 *
 * Output:          name
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetDeviceName(int iDeviceId, char *sname);

/*
 * Function:        raEnumerateAllDisks
 *
 * Description:     Enumerate all the disks
 *
 * Input:
 *
 * Output:          number of disks, ids of the disks
 *
 * Errors:
 *
 * Notes/Warnings: user should pass in an array of size at least RAMAX_DISK
 *
 */

RAIDAPI raeStatus raEnumerateAllDisks(int *nDisks, int idDisks[]);

/*
 * Function:        raGetDiskStatus
 *
 * Description:     Get the status of the disk, functional status and
 *                  assignment status (whether assigned to an array)
 *                  maintenance activity (idle, synchronize, rebuild) - added 09/13/00 Bld 46
 *                  S.M.A.R.T Status (self monitor status of drive) polling of SMART must be enabled in the
 *                                    driver startup parameters list
 *
 * Input:           Disk Id
 *
 * Output:          2 status values
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetDiskStatus(int iDeviceId, raeDiskFunctionalStatus *eDFStatus,
                                  raeDiskAssignmentStatus *eDAStatus,
								  raeDiskMaintenanceActivity *eDMStatus,
								  raeDiskSMARTStatus *eDSStatus);

/*
 * Function:        raGetDiskTiming
 *
 * Description:     Get the DMA timing for a particular disk
 *
 * Input:           Disk Id
 *
 * Output:          DMA Timing
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetDiskTiming(int iDeviceId, raeDiskTiming *eDiskTiming);

/*
 * Function:        raGetDiskSize
 *
 * Description:     Get Disk Size (in Blocks) and Block Size (in Bytes)
 *
 * Input:           Disk Id
 *
 * Output:          Disk Size, Block Size
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetDiskSize(int iDeviceId,  int *nBlocks, int *nBlockSize);
//RAIDAPI raeStatus raGetDiskSizeEx(int iDeviceId,  float *nBlocks, int *nBlockSize);

/*
 * Function:        raGetDiskDescription
 *
 * Description:     Get the Description of the disk (LBA, cylinder, head, sector)
 *
 * Input:           Disk Id
 *
 * Output:
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetDiskDescription(int iDeviceId, unsigned long *nLBA,int *nCyl, int *nHds, int *nSect);
//RAIDAPI raeStatus raGetDiskDescriptionEx(int iDeviceId, float *nLBA,int *nCyl, int *nHds, int *nSect);

/*
 * Function:        raCreateArray
 *
 * Description:     Create a new array from the specified disks
 *
 * Input:           name of array, raid mode, num disks, disk ids, stripe size
 *
 * Output:          Array id of newly created array
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */



RAIDAPI raeStatus raCreateArray(unsigned char *name, raeRaidMode eMode,
                                unsigned char numDisk, unsigned char *DiskIds,
                                unsigned short nStripeSize);

/*
 * Function:        raDeleteArray
 *
 * Description:     Delete an existing array
 *
 * Input:           ArrayId
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raDeleteArray(int iArrayId);

/*
 * Function:        raGetArrayStatus
 *
 * Description:     Gets the status of the array (functional status describes
 *                  whether the array is functioning, activity status describes
 *                  if the array is rebuilding or synchronizing)
 *
 * Input:           ArrayId
 *
 * Output:          functional status, activity status
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetArrayStatus(int iArrayId, raeArrayFunctionalStatus *eAFStatus,
                                   raeArrayActivityStatus *eAAStatus,
                                   int *nPercentdone);

/*
 * Function:        raEnumerateDisksInArray
 *
 * Description:     Lists all the disks in the array
 *
 * Input:           Array Id
 *
 * Output:          number of disks, individual ids of disks
 *
 * Errors:
 *
 * Notes/Warnings:  user should pass in an array of size at least RAMAX_DISK_PER_ARRAY
 *
 */

RAIDAPI raeStatus raEnumerateDisksInArray(int iArrayId, int *nDisks,
                                          int idDisks[]);

/*
 * Function:        raEnumerateAllArrays
 *
 * Description:     List all the arrays present
 *
 * Input:           none
 *
 * Output:          number of arrays, ids of the arrays
 *
 * Errors:
 *
 * Notes/Warnings:  user should pass in an array of size at least RAMAX_ARRAY
 *
 */

RAIDAPI raeStatus raEnumerateAllArrays(int *nArrays, int iArrayIds[]);

/*
 * Function:        raGetArrayDescription
 *
 * Description:     Get the Array description - RAID Mode, LBA Size and Stripe Block Size
 *
 * Input:           Array Id
 *
 * Output:          raid mode, lba size, stripe block size
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raGetArrayDescription(int iArrayId, raeRaidMode *eRaidMode,
                     unsigned long *nSize, int *nStripeBlockSize);


/*
 * Function:        raArraySynchronize
 *
 * Description:     Perform a Synchronize(Verify) on an array
 *
 * Input:           Array Id
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raArraySynchronize(int iArrayId, raeIgnoreFix eHandle);

/*
 * Function:        raArrayRebuildDisk
 *
 * Description:     Rebuild the specified disk
 *
 * Input:           Array Id, Disk Id
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:
 *
 */

RAIDAPI raeStatus raArrayRebuildDisk(int iArrayId, int iDiskinArray, raeIgnoreFix eHandle);

/*
 * Function:        raGetEvents
 *
 * Description:     Retrieve event log from the driver
 *
 * Input:           Pointer to rasEvent, number of events
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:  Event buffer should be at least RAMAX_EVENTS, which
 *                  is the maximum event size of the driver buffer
 *
 */

RAIDAPI raeStatus raGetEvents(rasEvent *pEvents, int *numevents);

/*
 * Function:        raGetDriverVersion
 *
 * Description:     Retrieve the driver version and file timestamp
 *
 * Input:           version buffer, timestamp buffer
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:  char buffer must be at least 256 bytes
 *
 */

RAIDAPI raeStatus raGetDriverVersion(char *version, char *timestamp);

/*
 * Function:        raEnclosureType
 *
 * Description:     Returns the type of enclosure for each drive.
 *
 * Input:           Disk ID, Pointer to enclosure type
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:  Care must be taken to track no drive present and no enclosure
 *                  messages and can only retrieve master drive's enclosure
 *
 */

RAIDAPI raeStatus raEnclosureType(int iDeviceID, raeEnclosureType *eEncType);


/*
 * Function:        raGetEnclosureStatus
 *
 * Description:     Returns either the size of the data area
 *                  needed for the current enclosure, or the
 *                  filled-out structure itself.
 *
 * Input:           Disk ID,
 *                  Pointer to enclosure type,
 *                  Pointer to enclosure structure size,
 *                  Pointer to enclosure structure
 *
 * Output:          none
 *
 * Errors:
 *
 * Notes/Warnings:  Client must know the enclosure type and pass in
 *                  the correct structure type for the pointer of sEncData
 *                  and can only retrieve master drive's enclosure
 *
 */

RAIDAPI raeStatus raGetEnclosureStatus(int iDeviceID,  raeEnclosureType *eEncType, int *sSize, void *sEncData);

/*Parameters:	iDeviceID - 0 = pri.master upto 3 = sec.slave
				iRate = place for synch rate to be returned.
Returns: reSNotImplemented or reSOK.

Description:   Return the current synch rate as an integer from 0 to 31. This applies to all Promise hardware on the system. If the driver does not support this feature the function will return
	-1 for the rate and the raeStatus parameter will be reSNotImplemented.
*/
raeStatus raGetSynchronizationRate(int iDeviceID,int *iRate);

/*
Parameters:  iDeviceId - 0=primary master,  up to 3=secondary slave
	         iRate = Synch rate.
Returns: reSNotImplemented or reSOK

Description:   Set the synchronization rate to between 0 and 31. This applies to all Promise hardware on the system. If the driver does not support this feature the function will return
	-1 for the rate and the raeStatus parameter will be reSNotImplemented.
*/
raeStatus raSetSynchronizationRate(int iDeviceId, int iRate);

/*
Parameters:  iDeviceId - 0=primary master,  up to 3=secondary slave
	         iRate = place for rebuild rate to be returned.
Returns: reSNotImplemented or reSOK

Description:   Get the current rebuild rate as an integer from 0 to 31. This applies to all Promise hardware on the system. If the driver does not support this feature the function will return
	-1 for the rate and the raeStatus parameter will be reSNotImplemented.
*/
raeStatus raGetRebuildRate(int iDeviceId, int *iRate);

raeStatus raSetRebuildRate(int iDeviceID, int iRate);

raeStatus raMapLogicalToPhysicalArray(int iLogical, int *iPhysical);

//need to be done by reevyn
raeStatus raExpanConv(int nArrayId,raeRaidMode eNewMode,int newnumDisk,int newDiskIds[],int nStripeSize,raeIgnoreFix eHandle);

raeStatus raExpanConvMode(int nArrayId, int newnumDisk, int newDiskIds[],int *numMode,raeRaidMode eNewMode[]);

raeStatus raGetExpanConvRate(int iDeviceID, int *iRate);

raeStatus raSetExpanConvRate(int iDeviceID, int iRate);

//new api added  by reevyn
RAIDAPI raeStatus raGetArrayInfo(int ArrayId, rasArrayInfo *aryinfo);
RAIDAPI raeStatus raGetChannelInfo(/*int AdapterId,*/ int ChannleId, rasChannelInfo *channelinfo);
//RAIDAPI raeStatus raGetDiskInfo(int bByArray, int ParentId,int DiskId,rasDiskInfo *diskinfo);
RAIDAPI raeStatus raCheckIntegrity(int ArrayId, raeIgnoreFix ehandle);
RAIDAPI raeStatus raGetErrorString(rasLogEvent *pev,unsigned int *pErrorLevel,char *str,char *timestamp,unsigned int *pCode,unsigned int *aID,unsigned int *dID,char *IDString,unsigned long *EventID);
RAIDAPI raeStatus raOriginalChannelCount(raeAction act, int *count);
RAIDAPI raeStatus raChannelThreshold(raeAction act, int *count);
RAIDAPI raeStatus raSmartCheckEnabled(raeAction act, int *benabled);
RAIDAPI raeStatus raMaintenanceLength(raeAction act, unsigned long *length);
RAIDAPI raeStatus raGetControllerInfo(int id, rasControllerInfo *controllerinfo);
RAIDAPI raeStatus raNeedUpdate(int *update);
RAIDAPI raeStatus raHasNewEvents(rasLogEvent *ev, unsigned long *num);

//for snmpsx
RAIDAPI raeStatus raWriteCacheEnabled(raeAction act, int *benabled);
RAIDAPI raeStatus raHotSwapEnabled(raeAction act, int *benabled);
//RAIDAPI raeStatus raAutoDupeDataEnabled(raeAction act, int *benabled);
RAIDAPI raeStatus raAlarmBuzzerEnabled(raeAction act, int *benabled);
RAIDAPI raeStatus raHotSparesEnabled(raeAction act, int *benabled);

//ADD 08-13
RAIDAPI raeStatus raReadThreshold(raeAction act, unsigned long *count);
RAIDAPI raeStatus raWriteThreshold(raeAction act, unsigned long *count);
RAIDAPI raeStatus raSubmitChannelThreshold(raeAction act, unsigned long *count);
RAIDAPI raeStatus raWriteMode(raeAction act, raeWriteMode *value);
//add 9.20
RAIDAPI raeStatus raRenameArray(unsigned long ArrayId, unsigned char *aryname);
//add 10.24 to support battery manage
RAIDAPI raeStatus raCheckBatteryBackModule(int *bexist);
RAIDAPI raeStatus raCheckBatteryPack(int *bexist);
RAIDAPI raeStatus raGetChargeStatus(raeBatteryStatus *status);
RAIDAPI raeStatus raGetChargeCycle(unsigned short *cycle);
RAIDAPI raeStatus raGetBatteryTemperature(unsigned short *temperature);
RAIDAPI raeStatus raGetBatteryVoltage(unsigned short *voltage);
RAIDAPI raeStatus raClearLog(void);
//add 2002.01.08 by steven
RAIDAPI raeStatus raGetHardwareType(raeHardwareType *eEncType);
RAIDAPI raeStatus raGetDimmSize(unsigned long AdapterId,unsigned long *DimmSize);
//add 2002.01.11 by steven
RAIDAPI raeStatus raGetDLLVersion(char* Version);
//add 2002.01.14 by steven
RAIDAPI raeStatus raGetArrayName(int iArrayID,char Name[]);

//<<add 2002.2.22
RAIDAPI raeStatus raCheckBusy(int *busy);

RAIDAPI raeStatus raResetHDInfo(); //<<add 2002.3.05

#ifdef __cplusplus
}
#endif

#endif /*_RAIDAPI_H*/


